import ConfigParser
import os

class _FakeSecHead(object):
    def __init__(self, fp):
        self.fp = fp
        self.sechead = '[section]\n'

    def readline(self):
        if self.sechead:
            try: 
                return self.sechead
            finally: 
                self.sechead = None
        else: 
            return self.fp.readline()

class parser:
    def __init__(self, filename):
        self.filename = filename
        self.fileopt = self.filename.split('.')[0]
        
    def _parse(self):
        with open(self.filename) as f:
            while True:
                line = f.readline()
    
                if line.__contains__('include'):
                    f.readline()
                    break
            config = ConfigParser.ConfigParser()
            config.readfp(_FakeSecHead(f))
        return config

    def write(self, outputfile):
        try:
            data = self._parse()
        except:
            return 1

        config = ConfigParser.ConfigParser()
        
        if not os.path.isfile(outputfile):
            for d in data.options('section'):
               if not d.__contains__('+') and not d.__contains__('?'):
                   config.add_section(d.upper()) 

        else:
            config.read(outputfile)
            for d in data.options('section'):
               if not (d.__contains__('+') \
                  or d.__contains__('?')) \
                  and not config.has_section(d.upper()):

                   config.add_section(d.upper()) 


        for d in data.options('section'):
            if (d.__contains__('+') or d.__contains__('?')):
                temp = data.get('section', d)
                if d[-2] == ' ':
                    d = d[:-2]
                else:
                    d = d[:-1]
                if config.has_option(d.upper(), self.fileopt):
                    temp += config.get(d.upper(), self.fileopt)

                config.set(d.upper(), 
                           self.fileopt, 
                           temp)
            else:
                config.set(d.upper(), 
                           self.fileopt, 
                           data.get('section', d))
        
        with open (outputfile, 'w') as o:
            config.write(o)
        return 0
